| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::ConnectionInterfaceContactGroupsInterface Class Reference
Connection proxies

`#include <TelepathyQt/Connection>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply SetContactGroups (uint contact, const QStringList &groups, int timeout=-1)
- QDBusPendingReply SetGroupMembers (const QString &group, const Tp::UIntList &members, int timeout=-1)
- QDBusPendingReply AddToGroup (const QString &group, const Tp::UIntList &members, int timeout=-1)
- QDBusPendingReply RemoveFromGroup (const QString &group, const Tp::UIntList &members, int timeout=-1)
- QDBusPendingReply RemoveGroup (const QString &group, int timeout=-1)
- QDBusPendingReply RenameGroup (const QString &oldName, const QString &newName, int timeout=-1)

## Signals

- void GroupsChanged (const Tp::UIntList &contact, const QStringList &added, const QStringList &removed)
- void GroupsCreated (const QStringList &names)
- void GroupRenamed (const QString &oldName, const QString &newName)
- void GroupsRemoved (const QStringList &names)

## Public Member Functions

- ConnectionInterfaceContactGroupsInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceContactGroupsInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceContactGroupsInterface (Tp::DBusProxy *proxy)
- ConnectionInterfaceContactGroupsInterface (const Tp::Client::ConnectionInterface &mainInterface)
- ConnectionInterfaceContactGroupsInterface (const Tp::Client::ConnectionInterface &mainInterface, QObject *parent)
- Tp::PendingVariant * requestPropertyDisjointGroups () const
- Tp::PendingVariant * requestPropertyGroupStorage () const
- Tp::PendingVariant * requestPropertyGroups () const
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.ContactGroups".

## Constructor & Destructor Documentation

Tp::Client::ConnectionInterfaceContactGroupsInterface::ConnectionInterfaceContactGroupsInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceContactGroupsInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceContactGroupsInterface::ConnectionInterfaceContactGroupsInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceContactGroupsInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceContactGroupsInterface::ConnectionInterfaceContactGroupsInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ConnectionInterfaceContactGroupsInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ConnectionInterfaceContactGroupsInterface::ConnectionInterfaceContactGroupsInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface | ) | `[explicit]`

Creates a ConnectionInterfaceContactGroupsInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::ConnectionInterfaceContactGroupsInterface::ConnectionInterfaceContactGroupsInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ConnectionInterfaceContactGroupsInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ConnectionInterfaceContactGroupsInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Connection.Interface.ContactGroups", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceContactGroupsInterface::requestPropertyDisjointGroups | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `DisjointGroups` of type `bool`.

True if each contact can be in at most one group; false if each contact can be in many groups.

This property cannot change after the connection has moved to the Connected state. Until then, its value is undefined, and it may change at any time, without notification.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceContactGroupsInterface::requestPropertyGroupStorage | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `GroupStorage` of type `uint`.

Indicates the extent to which contacts' groups can be set and stored. This property cannot change after the connection has moved to the Connected state. Until then, its value is undefined, and it may change at any time, without notification.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceContactGroupsInterface::requestPropertyGroups | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `Groups` of type `QStringList`.

The names of all groups that currently exist. This may be a larger set than the union of all contacts' `groups` contact attributes, if the connection allows groups to be empty.

Change notification is via GroupsCreated() and GroupsRemoved() ; clients can also distinguish between a create/remove pair and a renamed group by receiving GroupRenamed() .

This property's value is not meaningful until the ConnectionInterfaceContactListInterface::ContactListState has become Success.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ConnectionInterfaceContactGroupsInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactGroupsInterface::SetContactGroups | ( | uint | contact,
|  | const QStringList & | groups,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `SetContactGroups` on the remote object.

Add the given contact to the given groups (creating new groups if necessary), and remove them from all other groups.

This is the easiest and most correct way to implement user interfaces that display a single contact with a list of groups, resulting in a user expectation that when they apply the changes, the contact's set of groups will become exactly what was displayed.

If the user is removed from a group of which they were the only member, the group MAY be removed automatically.

In protocols like XMPP where groups behave like tags, a group with no members has no protocol representation.

Any GroupsCreated() , GroupsChanged() and GroupsRemoved() signals that result from this method call MUST be emitted before the method returns.

This method SHOULD NOT be called until the ConnectionInterfaceContactListInterface::ContactListState changes to Success. If the ContactListState is Failure, this method SHOULD raise the same error as ConnectionInterfaceContactListInterface::GetContactListAttributes() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  contact | The contact to alter.
  groups | The set of groups which the contact should be in.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactGroupsInterface::SetGroupMembers | ( | const QString & | group,
|  | const Tp::UIntList & | members,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `SetGroupMembers` on the remote object.

Add the given members to the given group (creating it if necessary), and remove all other members.

This is the easiest and most correct way to implement user interfaces that display a single group with a list of contacts, resulting in a user expectation that when they apply the changes, the groups's set of members will become exactly what was displayed.

If DisjointGroups is true, this will also remove each member from their previous group.

If the user is removed from a group of which they were the only member, the group MAY be removed automatically.

Any GroupsCreated() , GroupsChanged() and GroupsRemoved() signals that result from this method call MUST be emitted before the method returns.

This method SHOULD NOT be called until the ConnectionInterfaceContactListInterface::ContactListState changes to Success. If the ContactListState is Failure, this method SHOULD raise the same error as ConnectionInterfaceContactListInterface::GetContactListAttributes() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  group | The group to alter.
  members | The set of members for the group. If this set is empty, this method MAY remove the group.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactGroupsInterface::AddToGroup | ( | const QString & | group,
|  | const Tp::UIntList & | members,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `AddToGroup` on the remote object.

Add the given members to the given group, creating it if necessary.

If DisjointGroups is true, this will also remove each member from their previous group.

This is good for user interfaces in which you can edit groups via drag-and-drop.

Any GroupsCreated() , GroupsChanged() and GroupsRemoved() signals that result from this method call MUST be emitted before the method returns.

This method SHOULD NOT be called until the ConnectionInterfaceContactListInterface::ContactListState changes to Success. If the ContactListState is Failure, this method SHOULD raise the same error as ConnectionInterfaceContactListInterface::GetContactListAttributes() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  group | The group to alter.
  members | The set of members to include in the group.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactGroupsInterface::RemoveFromGroup | ( | const QString & | group,
|  | const Tp::UIntList & | members,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `RemoveFromGroup` on the remote object.

Remove the given members from the given group.

This is good for user interfaces in which you can edit groups via drag-and-drop.

Any GroupsChanged() or GroupsRemoved() signals that result from this method call MUST be emitted before the method returns.

This method SHOULD NOT be called until the ConnectionInterfaceContactListInterface::ContactListState changes to Success. If the ContactListState is Failure, this method SHOULD raise the same error as ConnectionInterfaceContactListInterface::GetContactListAttributes() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  group | The group to alter. If it does not exist, then it has no members by definition, so this method SHOULD return successfully.
  members | The set of members to remove from the group. It is not an error to remove members who are already not in the group. If there are no members left in the group afterwards, the group MAY itself be removed.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactGroupsInterface::RemoveGroup | ( | const QString & | group,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `RemoveGroup` on the remote object.

Remove all members from the given group, then remove the group itself. If the group already does not exist, this method SHOULD return successfully.

Any GroupsChanged() or GroupsRemoved() signals that result from this method call MUST be emitted before the method returns.

This method SHOULD NOT be called until the ConnectionInterfaceContactListInterface::ContactListState changes to Success. If the ContactListState is Failure, this method SHOULD raise the same error as ConnectionInterfaceContactListInterface::GetContactListAttributes() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  group | The group to remove.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactGroupsInterface::RenameGroup | ( | const QString & | oldName,
|  | const QString & | newName,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `RenameGroup` on the remote object.

Rename the given group.

On protocols where groups behave like tags, this is an API short-cut for adding all of the group's members to a group with the new name, then removing the old group.

Otherwise, clients can't perform this operation atomically, even if the connection could.

Any GroupRenamed() or GroupsRemoved() signals that result from this method call MUST be emitted before the method returns.

This method SHOULD NOT be called until the ConnectionInterfaceContactListInterface::ContactListState changes to Success. If the ContactListState is Failure, this method SHOULD raise the same error as ConnectionInterfaceContactListInterface::GetContactListAttributes() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  oldName | The group to rename.
  newName | The new name for the group.
  timeout | The timeout in milliseconds.

void Tp::Client::ConnectionInterfaceContactGroupsInterface::GroupsChanged | ( | const Tp::UIntList & | contact,
|  | const QStringList & | added,
|  | const QStringList & | removed
| ) |  | `[signal]`

Represents the signal `GroupsChanged` on the remote object.

Emitted when contacts' groups change.

Parameters:

  contact | The relevant contacts.
  added | The names of groups to which the contacts were added.
  removed | The names of groups from which the contacts were removed.

void Tp::Client::ConnectionInterfaceContactGroupsInterface::GroupsCreated | ( | const QStringList & | names | ) | `[signal]`

Represents the signal `GroupsCreated` on the remote object.

Emitted when new, empty groups are created. This will often be followed by GroupsChanged signals that add some members.

Parameters:

  names | The names of the new groups.

void Tp::Client::ConnectionInterfaceContactGroupsInterface::GroupRenamed | ( | const QString & | oldName,
|  | const QString & | newName
| ) |  | `[signal]`

Represents the signal `GroupRenamed` on the remote object.

Emitted when a group is renamed, in protocols where this can be distinguished from group creation, removal and membership changes.

Immediately after this signal is emitted, GroupsCreated() MUST signal the creation of a group with the new name, and GroupsRemoved() MUST signal the removal of a group with the old name.

Emitting these extra signals, in this order, means that clients that are interested in the set of groups that exist (but treat a rename and a create/remove pair identically) can ignore the GroupRenamed signal entirely.

If the group was not empty, immediately after those signals are emitted, GroupsChanged() MUST signal that the members of that group were removed from the old name and added to the new name.

On connection managers where groups behave like tags, renaming a group MAY be signalled as a set of GroupsCreated() , GroupsRemoved() and GroupsChanged() signals, instead of emitting this signal.

On protocols like XMPP, another resource "renaming a group" is indistinguishable from changing contacts' groups individually.

Parameters:

  oldName | The old name of the group.
  newName | The new name of the group.

void Tp::Client::ConnectionInterfaceContactGroupsInterface::GroupsRemoved | ( | const QStringList & | names | ) | `[signal]`

Represents the signal `GroupsRemoved` on the remote object.

Emitted when one or more groups are removed. If they had members at the time that they were removed, then immediately after this signal is emitted, GroupsChanged() MUST signal that their members were removed.

Emitting the signals in this order allows for two modes of operation. A client interested only in a contact's set of groups can ignore GroupsRemoved() and rely on the GroupsChanged() signal that will follow; a more elaborate client wishing to distinguish between all of a group's members being removed, and the group itself being removed, can additionally watch for GroupsRemoved() and use it to disambiguate.

Parameters:

  names | The names of the groups.

void Tp::Client::ConnectionInterfaceContactGroupsInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.